// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

struct point {
	int x, y;
	point(int _x, int _y) : x(_x), y(_y) {}

	point operator+(point const& other) const {
		return point(x + other.x, y + other.y);
	}

	point operator-(point const& other) const {
		return point(x - other.x, y - other.y);
	}

	point operator*(int num) const {
		return point(x * num, y * num);
	}

	int len() const {
		return max(abs(x), abs(y));
	}

	point norm() const {
		int tmp = max(abs(x), abs(y));
		return point(x / tmp, y / tmp);
	}

	bool operator<(point const& other) const {
		return pii(x, y) < pii(other.x, other.y);
	}
};

const int MAXC = 1000000;

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = opt<int>(1);

	int nodes = n / 3;
	vector<int> parent(nodes, -1);
	vector<vector<int>> tree(nodes);

	for (int i = 1; i < nodes; ++i) {
		int p = rnd.next(i);
		parent[i] = p;
		tree[p].push_back(i);
	}

	for (int i = nodes - 1; i > 0; --i) {
		if (szof(tree[i]) == 1) {
			int v = tree[i][0];
			tree[i].clear();
			parent[v] = parent[i];
			tree[parent[i]].push_back(v);
		}
	}

	set<point> outp;

	function<void(point, point, point, int)> rec = [&](point a, point b, point c, int v) {
		outp.insert(a);
		outp.insert(b);
		outp.insert(c);
		vector<point> triangle = {a, b, c};
		vector<int> left;
		for (int i = 0; i < 3; ++i) {
			int next = (i + 1) % 3;
			left.push_back((triangle[next] - triangle[i]).len());
		}
		vector<int> on_side(3);

		for (int it = 0; it < szof(tree[v]); ++it) {
			int tmp = rnd.next(left[0] + left[1] + left[2]);
			for (int i = 0; i < 3; ++i) {
				if (tmp < left[i]) {
					on_side[i]++;
					break;
				}
				tmp -= left[i];
			}
		}

		for (int i = 0; i < 3; ++i) {
			int next = (i + 1) % 3;
			int prev = (i + 2) % 3;
			if (!on_side[i]) {
				continue;
			}
			vector<int> parts(on_side[i], 1);
			int cur_len = (triangle[next] - triangle[i]).len();
			for (int j = on_side[i]; j < cur_len; ++j) {
				parts[rnd.next(on_side[i])]++;
			}

			int pref = 0;
			for (int j = 0; j < on_side[i]; ++j) {
				int to = tree[v].back();
				tree[v].pop_back();
				point na = triangle[i] + (triangle[next] - triangle[i]).norm() * pref;
				point nc = na + (triangle[prev] - triangle[i]).norm() * parts[j];
				pref += parts[j];
				point nb = triangle[i] + (triangle[next] - triangle[i]).norm() * pref;
				rec(na, nb, nc, to);
			}
		}
	};

	rec(point(-MAXC, -MAXC), point(MAXC, -MAXC), point(-MAXC, MAXC), 0);

	assert(szof(outp) <= n);

	cout << szof(outp) << "\n";
	vector<point> arr_outp(outp.begin(), outp.end());
	shuffle(arr_outp.begin(), arr_outp.end());

	for (auto p : arr_outp) {
		cout << p.x << " " << p.y << "\n";
	}

	return 0;
}