// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n;
	cin >> n;

	vector<pii> points;
	map<int, vector<int>> by_x, by_y, by_xpy, by_xmy;
	for (int i = 0; i < n; ++i) {
		int x, y;
		cin >> x >> y;
		points.push_back({x, y});
		by_x[x].push_back(i);
		by_y[y].push_back(i);
		by_xpy[x + y].push_back(i);
		by_xmy[x - y].push_back(i);
	}

	vector<vector<int>> graph(n);

	auto add_edge = [&](int a, int b) {
		graph[a].push_back(b);
		graph[b].push_back(a);
	};

	for (auto& p : by_x) {
		sort(p.ss.begin(), p.ss.end(), [&](int a, int b) {
			return points[a].ss < points[b].ss;
		});
		for (int i = 0; i < szof(p.ss) - 1; ++i) {
			add_edge(p.ss[i], p.ss[i + 1]);
		}
	}

	for (auto& p : by_y) {
		sort(p.ss.begin(), p.ss.end(), [&](int a, int b) {
			return points[a].ff < points[b].ff;
		});
		for (int i = 0; i < szof(p.ss) - 1; ++i) {
			add_edge(p.ss[i], p.ss[i + 1]);
		}
	}

	for (auto& p : by_xpy) {
		sort(p.ss.begin(), p.ss.end(), [&](int a, int b) {
			return points[a].ff < points[b].ff;
		});
		for (int i = 0; i < szof(p.ss) - 1; ++i) {
			add_edge(p.ss[i], p.ss[i + 1]);
		}
	}

	for (auto& p : by_xmy) {
		sort(p.ss.begin(), p.ss.end(), [&](int a, int b) {
			return points[a].ff < points[b].ff;
		});
		for (int i = 0; i < szof(p.ss) - 1; ++i) {
			add_edge(p.ss[i], p.ss[i + 1]);
		}
	}

	for (int i = 0; i < n; ++i) {
		sort(graph[i].begin(), graph[i].end(), [&](int a, int b) {
			return pii(szof(graph[a]), a) < pii(szof(graph[b]), b);
		});
	}

	int ans = 0;

	vector<int> used_neib(n, -1);

	for (int i = 0; i < n; ++i) {
		for (int to : graph[i]) {
			used_neib[to] = i;
		}
		for (int j : graph[i]) {
			if (pii(szof(graph[j]), j) >= pii(szof(graph[i]), i)) {
				break;
			}

			for (int k : graph[j]) {
				if (pii(szof(graph[k]), k) >= pii(szof(graph[j]), j)) {
					break;
				}
				if (used_neib[k] == i) {
					++ans;
				}
			}
		}
	}

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}