// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n;
	cin >> n;
	vector<pii> points;
	map<int, vector<int>> by_x, by_y, by_xpy, by_xmy;
	for (int i = 0; i < n; ++i) {
		int x, y;
		cin >> x >> y;
		points.push_back({x, y});
		by_x[x].push_back(y);
		by_y[y].push_back(x);
		by_xpy[x + y].push_back(x);
		by_xmy[x - y].push_back(x);
	}

	for (auto& p : by_x) {
		sort(p.ss.begin(), p.ss.end());
	}

	for (auto& p : by_y) {
		sort(p.ss.begin(), p.ss.end());
	}

	for (auto& p : by_xpy) {
		sort(p.ss.begin(), p.ss.end());
	}

	for (auto& p : by_xmy) {
		sort(p.ss.begin(), p.ss.end());
	}

	auto check = [&](vector<int> const& arr, int from, int to) {
		return lower_bound(arr.begin(), arr.end(), to) - lower_bound(arr.begin(), arr.end(), from) == 1;
	};

	auto check_x = [&](int x, int from, int to) {
		return check(by_x[x], from, to);
	};

	auto check_y = [&](int y, int from, int to) {
		return check(by_y[y], from, to);
	};

	auto check_xpy = [&](int xpy, int from, int to) {
		return check(by_xpy[xpy], from, to);
	};

	auto check_xmy = [&](int xmy, int from, int to) {
		return check(by_xmy[xmy], from, to);
	};

	int ans = 0;

	for (auto [x, y] : points) {
		auto& cur_by_x = by_x[x];
		auto& cur_by_y = by_y[y];
		auto& cur_by_xpy = by_xpy[x + y];
		auto& cur_by_xmy = by_xmy[x - y];
		auto it_x = lower_bound(cur_by_x.begin(), cur_by_x.end(), y);
		auto it_x2 = it_x; ++it_x2;
		auto it_y = lower_bound(cur_by_y.begin(), cur_by_y.end(), x);
		auto it_y2 = it_y; ++it_y2;
		auto it_xpy = lower_bound(cur_by_xpy.begin(), cur_by_xpy.end(), x);
		auto it_xpy2 = it_xpy; ++it_xpy2;
		auto it_xmy = lower_bound(cur_by_xmy.begin(), cur_by_xmy.end(), x);
		auto it_xmy2 = it_xmy; ++it_xmy2;

		int d1 = INF, d2 = INF, d3 = INF, d4 = INF, d5 = INF, d6 = INF, d7 = INF, d8 = INF;

		if (it_x2 != cur_by_x.end()) {
			d1 = *it_x2 - y;
		}

		if (it_xmy2 != cur_by_xmy.end()) {
			d2 = *it_xmy2 - x;
		}

		if (it_y2 != cur_by_y.end()) {
			d3 = *it_y2 - x;
		}

		if (it_xpy2 != cur_by_xpy.end()) {
			d4 = *it_xpy2 - x;
		}

		if (it_x != cur_by_x.begin()) {
			--it_x;
			d5 = y - *it_x;
		}

		if (it_xmy != cur_by_xmy.begin()) {
			--it_xmy;
			d6 = x - *it_xmy;
		}

		if (it_y != cur_by_y.begin()) {
			--it_y;
			d7 = x - *it_y;
		}

		if (it_xpy != cur_by_xpy.begin()) {
			--it_xpy;
			d8 = x - *it_xpy;
		}



		if (d1 == d3 && d1 < INF) {
			ans += check_xpy(x + y + d1, x, x + d1);
		}

		if (d2 == d4 && d2 < INF) {
			ans += check_x(x + d2, y - d2, y + d2);
		}

		if (d3 == d5 && d3 < INF) {
			ans += check_xmy(x - y + d3, x, x + d3);
		}

		if (d4 == d6 && d4 < INF) {
			ans += check_y(y - d4, x - d4, x + d4);
		}

		if (d5 == d7 && d5 < INF) {
			ans += check_xpy(x + y - d5, x - d5, x);
		}

		if (d6 == d8 && d6 < INF) {
			ans += check_x(x - d6, y - d6, y + d6);
		}

		if (d7 == d1 && d7 < INF) {
			ans += check_xmy(x - y - d7, x - d7, x);
		}

		if (d8 == d2 && d8 < INF) {
			ans += check_y(y + d8, x - d8, x + d8);
		}
	}

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}