/// Created by Arsenii Kirillov
 
#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
#define fi first
#define se second
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()
#ifndef LOCAL
#  define cerr __get_ce
#endif
 
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
 
/*
using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;
//*/
 
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

struct val {
	ll cnt;
	int pref, suf, sum, len;
	val (ll cnt_ = 0, int pref_ = 0, int suf_ = 0, int sum_ = 0, int len_ = 0): cnt(cnt_), pref(pref_), suf(suf_), sum(sum_), len(len_) {};
}; 

val zero;

const int mem = 27;
val mas[mem][(int)4e5 + 10];

val make(val &a, val &b) {
	val ans;
	ans.sum = a.sum ^ b.sum;
	ans.len = a.len + b.len;
	ans.pref = a.pref;
	if (a.sum)
		ans.pref += b.len - b.pref;
	else
		ans.pref += b.pref;
	ans.suf = b.suf;
	if (b.sum)
		ans.suf += a.len - a.suf;
	else
		ans.suf += a.suf;
	ans.cnt = a.cnt + b.cnt + (ll)a.suf * (b.len - b.pref) + (a.len - a.suf) * (ll)b.pref;
	return ans;
}

void init(int id, int v, int l, int r) {
	mas[id][v].len = r - l;
	if (r - l > 1) {
		int m = (l + r) / 2;
		init(id, 2 * v + 1, l, m);
		init(id, 2 * v + 2, m, r);
	}
}

void add(int id, int v, int l, int r, int q) {
	if (r - l == 1) {
		mas[id][v].sum ^= 1;
		mas[id][v].cnt ^= 1;
		mas[id][v].pref ^= 1;
		mas[id][v].suf ^= 1;
		return;
	}
	int m = (l + r) / 2;
	if (q < m)
		add(id, 2 * v + 1, l, m, q);
	else
		add(id, 2 * v + 2, m, r, q);
	mas[id][v] = make(mas[id][2 * v + 1], mas[id][2 * v + 2]);
}

val get(int id, int v, int l, int r, int q, int w) {
	if (l >= w || r <= q)
		return zero;
	if (q <= l && r <= w)
		return mas[id][v];
	int m = (l + r) / 2;
	if (q >= m)
		return get(id, 2 * v + 2, m, r, q, w);
	if (w <= m)
		return get(id, 2 * v + 1, l, m, q, w);
	val a = get(id, 2 * v + 1, l, m, q, w);
	val b = get(id, 2 * v + 2, m, r, q, w);
	return make(a, b);
}
 
void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> mas(n);
	for (int j = 0; j < mem; j++)
		init(j, 0, 0, n);
	for (int i = 0; i < n; i++) {
		cin >> mas[i];
		for (int j = 0; j < mem; j++) {
			if (mas[i] & (1 << j)) {
				add(j, 0, 0, n, i);
			}
		}
	}
	for (int i = 0; i < m; i++) {
		int t;
		cin >> t;
		if (t == 1) {
			int ind, x;
			cin >> ind >> x;
			ind--;
			for (int j = 0; j < mem; j++) {
				if ((mas[ind] & (1 << j)) != (x & (1 << j)))
					add(j, 0, 0, n, ind);
			}
			mas[ind] = x;
		} else {
			int l, r;
			cin >> l >> r;
			ll ans = 0;
			for (int j = 0; j < mem; j++) {
				val cur = get(j, 0, 0, n, l - 1, r);
				ans += (1ll << j) * cur.cnt;
			}
			cout << ans << "\n";
		}
	}
}
 
 
int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
 
	int test_count = 1;
	//cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
 
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}