// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

struct info {
	ll res;
	int prefs;
	int len;
	bool tot;
	info() : res(0), prefs(0), len(0), tot(0) {}
	info(int val) : len(1) {
		if (val == 0) {
			res = 0;
			prefs = 0;
			tot = 0;
		} else {
			res = 1;
			prefs = 1;
			tot = 1;
		}
	}

	int get_prefs(int val) const {
		if (val == 1) {
			return prefs;
		}
		return len - prefs;
	}

	int get_suffs(int val) const {
		int ret = get_prefs(tot ^ val);
		if (val == 0) {
			--ret;
		}
		if (val == tot) {
			++ret;
		}
		return ret;
	}
};

info comb(info const& v1, info const& v2) {
	info ret;
	ret.res = v1.res + v2.res + (ll) v1.get_suffs(0) * v2.get_prefs(1) + (ll) v1.get_suffs(1) * v2.get_prefs(0);
	ret.prefs = v1.prefs + v2.get_prefs(!v1.tot);
	ret.len = v1.len + v2.len;
	ret.tot = v1.tot ^ v2.tot;
	return ret;
}

const int P = 27;

void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> arr;
	for (int i = 0; i < n; ++i) {
		int num;
		cin >> num;
		arr.push_back(num);
	}

	int bpv = 1;
	while (bpv < n) {
		bpv *= 2;
	}

	vector<vector<info>> segtrees(P, vector<info>(bpv * 2));

	for (int b = 0; b < P; ++b) {
		for (int i = 0; i < n; ++i) {
			segtrees[b][bpv + i] = info((arr[i] >> b) & 1);
		}
		for (int i = bpv - 1; i; --i) {
			segtrees[b][i] = comb(segtrees[b][i * 2], segtrees[b][i * 2 + 1]);
		}
	}

	auto segtree_get = [&](int b, int l, int r) {
		l += bpv; r += bpv;
		info lpart, rpart;
		while (l < r) {
			if (l & 1) {
				lpart = comb(lpart, segtrees[b][l++]);
			}
			if (r & 1) {
				rpart = comb(segtrees[b][--r], rpart);
			}
			l /= 2; r /= 2;
		}
		return comb(lpart, rpart);
	};

	for (int i = 0; i < m; ++i) {
		int t;
		cin >> t;
		if (t == 1) {
			int pos, val;
			cin >> pos >> val;
			--pos;
			for (int b = 0; b < P; ++b) {
				int tmp = pos + bpv;
				segtrees[b][tmp] = info((val >> b) & 1);
				tmp /= 2;
				while (tmp) {
					segtrees[b][tmp] = comb(segtrees[b][tmp * 2], segtrees[b][tmp * 2 + 1]);
					tmp /= 2;
				}
			}
		} else {
			int l, r;
			cin >> l >> r;
			--l;
			ll ans = 0;
			for (int b = 0; b < P; ++b) {
				ans += segtree_get(b, l, r).res * (1 << b);
			}
			cout << ans << "\n";
		}
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}