#include "testlib.h"
#include <vector>
#include <algorithm>

const int MAXN[] = {
    10,           // sample
    100000,       // 1
    100,          // 2
    100000,       // 3
};

const long long MAXD = 1e18;
const long long MAXT = 1e18;

struct clas {
    long long s, f, t;
    clas(long long s, long long f, long long t) : s(s), f(f), t(t) {}
};

int cmp(clas* a, clas* b) {
    if (a->s != b->s) {
        return a->s < b->s;
    }
}

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);

    auto gr = validator.group().empty() ? 0 : validator.group()[0] - '0';

    long long n = inf.readLong(1ll, MAXN[gr], "n");
    inf.readSpace();
    long long d = inf.readLong(1ll, MAXD, "d");
    inf.readSpace();
    long long t = inf.readLong(1ll, MAXT, "t");
    inf.readEoln();
    std::vector<clas*> classes;  
    for (int i = 0; i < n; i++) {
        long long a = inf.readLong(t, d - t, "l_i");
        inf.readSpace();
        long long b = inf.readLong(t, d - t, "r_i");
        ensure(a < b);
        inf.readSpace();
        long long t = inf.readLong(0ll, 1ll, "type");
        classes.push_back(new clas(a, b, t));
        if (gr == 1) {
            ensuref(t == 0, "group 1");
        }
        inf.readEoln();
    }
    std::sort(classes.begin(), classes.end(), cmp);
    for (int i = 0; i < n - 1; i++) {
        ensuref(classes[i]->f <= classes[i + 1]->s, "classes intersecting");
    }
    inf.readEof();
    return 0;
}
