// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
typedef pair<ll, ll> pll;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n;
	ll d, t;
	cin >> n >> d >> t;
	vector<pair<pll, int>> segs;
	for (int i = 0; i < n; ++i) {
		ll l, r;
		int type;
		cin >> l >> r >> type;
		type = 1 - type;
		segs.push_back({{l, r}, type});
	}

	sort(segs.begin(), segs.end());

	vector<pair<pll, int>> st;
	for (auto seg : segs) {
		while (szof(st) && (st.back().ss || seg.ss) && seg.ff.ff - st.back().ff.ss < t * (st.back().ss + seg.ss)) {
			seg.ff.ff = st.back().ff.ff;
			seg.ss |= st.back().ss;
			st.pop_back();
		}
		st.push_back(seg);
	}

	ll ans = d;
	for (auto seg : st) {
		// cerr << seg.ff.ff << " " << seg.ff.ss << " " << seg.ss << endl;
		if (seg.ss) {
			ans -= t * 2 + seg.ff.ss - seg.ff.ff;
		}
	}

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}