#include "testlib.h"
#include <string>
#include <unordered_set>

using namespace std;

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);
    int g = validator.group() == "" ? 4 : validator.group()[0] - '0';
    if (g == 0) {
        g = 4;
    }

    int nlimit = g < 3 ? 10 : (g < 4 ? 100 : 300);
    int slimit = g < 2 ? 10 : (g < 4 ? 100 : 300);

    int n = inf.readInt(1, nlimit, "n");
    inf.readSpace();
    int m = inf.readInt(1, nlimit, "m");
    inf.readEoln();

    inf.readInt(1, n, "s_x");
    inf.readSpace();
    inf.readInt(1, m, "s_y");
    inf.readEoln();

    unordered_set<char> met;
    for (int i = 0; i < n; i++) {
        string x = inf.readToken("[a-z]+", "x_i");
        inf.readEoln();
        ensuref(m == (int) x.size(), "Matrix line %d has size %d instead of %d", i, x.size(), m);
        for (char c : x) {
            met.insert(c);
        }
    }
    ensuref(met.size() == 'z' - 'a' + 1, "Not every letter is present");

    string s = inf.readToken("[a-z]+", "s");
    ensuref(s.size() <= slimit, "String s have size %d but should not exceed %d", s.size(), slimit);
    inf.readEoln();
    inf.readEof();
}