// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

int dx[4] = {1, 0, -1, 0};
int dy[4] = {0, 1, 0, -1};

void solve() {
	int n, m;
	cin >> n >> m;
	int sx, sy;
	cin >> sx >> sy;
	--sx; --sy;
	vector<string> field;
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		field.push_back(s);
	}
	string s;
	cin >> s;

	vector<vector<vector<int>>> dist(szof(s) + 1, vector<vector<int>>(n, vector<int>(m, 300 * 600)));
	dist[0][sx][sy] = 0;
	queue<tuple<int, int, int>> qu;
	qu.push({0, sx, sy});
	while (szof(qu)) {
		auto [p, x, y] = qu.front();
		qu.pop();
		if (p == szof(s)) {
			cout << dist[p][x][y] - szof(s) << "\n";
			break;
		}
		if (s[p] == field[x][y]) {
			if (dist[p + 1][x][y] > dist[p][x][y] + 1) {
				dist[p + 1][x][y] = dist[p][x][y] + 1;
				qu.push({p + 1, x, y});
			}
		}
		for (int d = 0; d < 4; ++d) {
			int nx = x + dx[d];
			int ny = y + dy[d];
			if (0 <= nx && nx < n && 0 <= ny && ny < m && dist[p][nx][ny] > dist[p][x][y] + 1) {
				dist[p][nx][ny] = dist[p][x][y] + 1;
				qu.push({p, nx, ny});
			}
		}
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}