#include <iostream>
#include <string>
#include <vector>
#include <queue>

using namespace std;

unsigned int n, m;

struct pos {
    unsigned int level;
    unsigned int i;
    unsigned int j;

    unsigned int loc() {
        return level * n * m + i * m + j;
    }
};

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    unsigned int sx, sy;
    cin >> n >> m >> sx >> sy;
    vector<string> x(n);
    for (unsigned int i = 0; i < n; i++) {
        cin >> x[i];
    }

    string s;
    cin >> s;
    unsigned int c = n * m * s.size();

    vector<unsigned int> dist(c, -1);
    queue<pos> q;
    pos start{0, sx - 1, sy - 1};
    q.push(start);
    dist[start.loc()] = 0;
    while (!q.empty()) {
        pos p = q.front();
        q.pop();

        vector<pos> edges;
        if (p.i > 0) {
            edges.push_back(pos{p.level, p.i - 1, p.j});
        }
        if (p.i < n - 1) {
            edges.push_back(pos{p.level, p.i + 1, p.j});
        }
        if (p.j > 0) {
            edges.push_back(pos{p.level, p.i, p.j - 1});
        }
        if (p.j < m - 1) {
            edges.push_back(pos{p.level, p.i, p.j + 1});
        }
        if (p.level < s.size() - 1 && x[p.i][p.j] == s[p.level]) {
            edges.push_back(pos{p.level + 1, p.i, p.j});
        }

        for (auto &nxt : edges) {
            if (dist[nxt.loc()] > dist[p.loc()] + 1) {
                dist[nxt.loc()] = dist[p.loc()] + 1;
                q.push(nxt);
            }
        }
    }

    unsigned int ans = -1;
    for (unsigned int i = 0; i < n; i++) {
        for (unsigned int j = 0; j < m; j++) {
            if (x[i][j] == s.back()) {
                ans = min(ans, dist[pos{s.size() - 1, i, j}.loc()]);
            }
        }
    }
    cout << ans - s.size() + 1 << '\n';

}