#include <iostream>
#include <string>
#include <vector>
#include <queue>

using namespace std;

unsigned int n, m;

unsigned int iabs(int t) {
    return t >= 0 ? t : -t;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int sx, sy;
    cin >> n >> m >> sx >> sy;
    sx--;
    sy--;
    vector<string> x(n);
    vector<vector<pair<int, int>>> pos('z' - 'a' + 1);
    for (unsigned int i = 0; i < n; i++) {
        cin >> x[i];
        for (unsigned int j = 0; j < m; j++) {
            pos[x[i][j] - 'a'].push_back({i, j});
        }
    }

    string s;
    cin >> s;

    vector<vector<vector<unsigned int>>> dp(s.size() + 1, vector<vector<unsigned int>>(n, vector<unsigned int>(m, -1)));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            dp[0][i][j] = iabs(i - sx) + iabs(j - sy);
        }
    }
    for (int layer = 1; layer <= s.size(); layer++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (x[i][j] == s[layer - 1]) {
                    dp[layer][i][j] = dp[layer - 1][i][j];
                } else {
                    for (auto &p : pos[s[layer - 1] - 'a']) {
                        dp[layer][i][j] = min(dp[layer][i][j],
                                              dp[layer - 1][p.first][p.second] + iabs(i - p.first) + iabs(j - p.second));
                    }
                }
            }
        }
    }

    unsigned int ans = -1;
    for (unsigned int i = 0; i < n; i++) {
        for (unsigned int j = 0; j < m; j++) {
            ans = min(ans, dp[s.size()][i][j]);
        }
    }
    cout << ans << '\n';

}