#include <iostream>
#include <string>
#include <vector>
#include <queue>

using namespace std;

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    unsigned int n, m, sx, sy;
    cin >> n >> m >> sx >> sy;
    vector<string> x(n);
    for (unsigned int i = 0; i < n; i++) {
        cin >> x[i];
    }

    string s;
    cin >> s;
    unsigned int c = n * m * s.size();
    vector<vector<unsigned int>> graph(c);
    vector<unsigned int> dist(c, -1);
    auto item = [&](unsigned int l, unsigned int i, unsigned int j) {
        return l * n * m + i * m + j;
    };

    for (unsigned int layer = 0; layer < s.size(); layer++) {
        for (unsigned int i = 0; i < n; i++) {
            for (unsigned int j = 0; j < m; j++) {
                unsigned int idx = item(layer, i, j);
                if (i > 0) {
                    graph[idx].push_back(item(layer, i - 1, j));
                }
                if (i < n - 1) {
                    graph[idx].push_back(item(layer, i + 1, j));
                }
                if (j > 0) {
                    graph[idx].push_back(item(layer, i, j - 1));
                }
                if (j < m - 1) {
                    graph[idx].push_back(item(layer, i, j + 1));
                }
                if (layer < s.size() - 1 && x[i][j] == s[layer]) {
                    graph[idx].push_back(item(layer + 1, i, j));
                }
            }
        }
    }

    unsigned int start = item(0, sx - 1, sy - 1);
    queue<unsigned int> q;
    q.push(start);
    dist[start] = 0;
    while (!q.empty()) {
        unsigned int idx = q.front();
        q.pop();

        for (unsigned int nxt: graph[idx]) {
            if (dist[nxt] > dist[idx] + 1) {
                dist[nxt] = dist[idx] + 1;
                q.push(nxt);
            }
        }
    }

    unsigned int ans = -1;
    for (unsigned int i = 0; i < n; i++) {
        for (unsigned int j = 0; j < m; j++) {
            if (x[i][j] == s.back()) {
                ans = min(ans, dist[item(s.size() - 1, i, j)]);
            }
        }
    }
    cout << ans - s.size() + 1 << '\n';

}